/*******************************************************************************
+
+  LEDA  2.1.1                                                 11-15-1991
+
+
+  b_heap.h
+
+
+  Copyright (c) 1991  by  Max-Planck-Institut fuer Informatik
+  Im Stadtwald, 6600 Saarbruecken, FRG     
+  All rights reserved.
+ 
*******************************************************************************/




#ifndef BHEAPH
#define BHEAPH

#include <LEDA/basic.h>
#include <LEDA/list.h>
#include <LEDA/array.h>

//------------------------------------------------------------------------------
// b_heap: bounded heaps with keys from [a..b]
//
// Stefan Naeher  (1989)
//------------------------------------------------------------------------------

class b_heap_node {

friend class b_heap;
friend void print_b_heap_item(b_heap_node*);

int key;
ent info;
list_item loc;

b_heap_node(int k, ent i ) 
{ 
  key = k; info = i; loc = 0; }

 OPERATOR_NEW(3)
 OPERATOR_DEL(3)

};

typedef b_heap_node* b_heap_item;
declare(list,b_heap_item)

typedef list(b_heap_item)* b_heap_bucket;

declare(array,b_heap_bucket)

class b_heap {

    int min;
    int max;
    int low;
    int high;
    
    array(b_heap_bucket)  T;


public:

b_heap(int a, int b);
~b_heap() { clear(); }
b_heap_item insert(int key, ent info) ;

b_heap_item find_min();
b_heap_item find_max();
ent del_min();
ent del_max();
b_heap_item decrease_key(b_heap_item it, int k);
b_heap_item increase_key(b_heap_item it, int k);

void delete_item(b_heap_item it);
void clear();

ent info(b_heap_item it) { return it->info; }
int key(b_heap_item it)  { return it->key; }
int empty()              { return (find_min()==0) ? true : false; }

void print();

};

#endif

