/*******************************************************************************
+
+  LEDA  2.1.1                                                 11-15-1991
+
+
+  plane_alg.h
+
+
+  Copyright (c) 1991  by  Max-Planck-Institut fuer Informatik
+  Im Stadtwald, 6600 Saarbruecken, FRG     
+  All rights reserved.
+ 
*******************************************************************************/



#ifndef PLANE_ALGH
#define PLANE_ALGH

#include <LEDA/plane.h>
#include <LEDA/graph.h>

declare2(GRAPH,point,int)
declare2(GRAPH,point,point)


//------------------------------------------------------------------------------
// line sweep for straight line segments
//------------------------------------------------------------------------------

overload SWEEP_SEGMENTS;

void SWEEP_SEGMENTS(list(segment)&, list(segment)&, GRAPH(point,int)&);

void SWEEP_SEGMENTS(list(segment)&, list(point)&);


inline void SEGMENT_INTERSECTION(list(segment)& L, list(point)& P)
{ SWEEP_SEGMENTS(L,P); }


//------------------------------------------------------------------------------
// convex hull
//------------------------------------------------------------------------------

polygon CONVEX_HULL(list(point));


//------------------------------------------------------------------------------
// voronoi diagrams
//------------------------------------------------------------------------------

void VORONOI(list(point)& sites, double R, GRAPH(point,point)& VD);


#endif
