case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
    fi 2>/dev/null
    . config.sh
    ;;
esac
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac
echo "Extracting man/kit.$manext (with variable substitutions)"
$rm -f kit.$manext
$spitshell >kit.$manext <<!GROK!THIS!
.TH KIT $manext ram
''' @(#) Manual page for mailing kit -- (c) ram July 1990
'''
''' $Id: kit.SH,v 2.0.1.5 91/11/25 15:53:01 ram Exp $
'''
''' $Log:	kit.SH,v $
''' Revision 2.0.1.5  91/11/25  15:53:01  ram
''' patch9: added kit's -M option to include minikit
''' patch9: documents the tar -o possible problem
''' 
''' Revision 2.0.1.4  91/11/25  12:10:23  ram
''' patch8: documents new -l option for kit and mailkit
''' 
''' Revision 2.0.1.3  91/05/27  14:32:48  ram
''' patch5: search for config.sh is now silent
''' patch5: documented new options -d and -n for kit
''' patch5: new option -n for mailkit
''' patch5: the 'kit .' bug has now a workaround thanks to -d
''' patch5: new example to show usage of -d and -n
''' 
''' Revision 2.0.1.2  91/04/30  13:38:47  ram
''' patch3: fixed some English mistakes/misspellings
''' patch3: unshar is no longer needed to unkit (built-in)
''' patch3: the NOTE section has been revised
''' 
''' Revision 2.0.1.1  91/04/01  15:52:58  ram
''' patch1: documented the new kit options -x, -k and -X
''' patch1: new naming conventions for split files are described
''' 
''' Revision 2.0  91/02/19  15:50:28  ram
''' Baseline for first official release.
''' 
'''
.SH NAME
kit, mailkit, unkit \- the ultimate mailing tools
.SH SYNOPSIS
\fBkit\fR [ \fB\-EFHMBVXefhpx\fR ] [ \fB\-k\fI key\fR]
[ \fB\-d\fI dir\fR ] [ \fB\-m\fI address\fR ] [ \fB\-n\fI basename\fR ]
[ \fB\-l\fI file\fR ] [ \fB\-s\fI name\fR ] \fIdirectories\fR | \fIfiles\fR
.br
\fBmailkit\fR [ \fB\-EFVefhp\fR ] [ \fB\-l\fI file\fR ]
[ \fB\-n\fI partname\fR ] \fItitle\fR [ \fIaddress(es)\fR ]
.br
\fBunkit\fR [ \fB\-hlprV\fR ] [ \fIfiles\fR ]
.SH DESCRIPTION
\fIKit\fR is the ultimate mailing tool. It enables you to mail
data without any consideration of possible escape sequences or
control characters.
Given a file name or a directory, it builds a single file using
\fItar\fR(1) and \fIcompress\fR(1). Then this file is hex-encoded
(option \fB\-H\fR) or ASCII-encoded with \fIbtoa\fR(1)
(option \fB\-B\fR, which is used by default) before being shell-archived
by \fImakekit\fR(1).
\fIKit\fR produces files that match "Kit*" regular expression.
This default base name can be changed thanks to \fB\-n\fR option.
On invocation, it removes all previously existing "Kit*" files.
With \fB\-m\fR option, it is possible to give one mail address, and
\fIkit\fR will invoke \fImailkit\fR to send the archive. There may be
as many \fB\-m\fR options as needed (to send the same archive to more
than a single person).
If there are a lot of recipients, you may want to store them in a file
and use the \fB\-l\fR option to tell \fIkit\fR where the recipient file
is located.
.PP
The \fB\-E\fR, \fB\-F\fR, \fB\-e\fR, \fB\-f\fR and \fB\-p\fR options are
passed on to \fImailkit\fR, so
if no \fB\-m\fR option is used, they will be ignored. When sending
files with \fB\-m\fR, the subject of the message holds the name of
the first file given in the command line (supposed to be the name
of the kit). It is possible to overwrite this default by using the
\fB\-s\fR option.
.PP
If you want to send sensible data, it is possible to encrypt them using
a public-domain implementation of Data Encryption Standard (DES).
The \fB\-x\fR option will use the Cipher Block Chaining mode (default),
while \fB\-X\fR requests the Electronic Code Book mode. If you do not
specify the encryption key with \fB\-k\fR, \fIdes\fR(1) will prompt you
for one. If you use the \fB\-k\fR option, \fB\-x\fR is assumed.
.PP
It may happen that there are no write permissions in the directory
where the root directory to be kitted lies. The \fB-d\fR option enables
you to specify another directory, where all the temporary files will be
stored. If you use something like \fI/tmp\fR, you must be careful to use
\fB\-n\fR to change the base name used (in case someone else is doing
the same thing, otherwise files may get mangled).
.PP
When you send a kit to someone which may not have \fIkit\fR, the \fB\-M\fR
option may be used to include a \fIminikit\fR script, which is a minimal
set of commands to unkit an unencrypted ASCII-encoded kit. The overhead is
small (around 4K) and some instructions are provided in the header of every
kit part. The minikit is usually called \fIminikit\fR, but should you
already have a file with that name in your distribution, it will be renamed
\fIMINIKIT\fR. If by chance (!) you named one of your files MINIKIT, then
a unique name of the form \fImkitXXXXX\fR will be generated (XXXXX stands
for the PID of the \fIkit\fR process).
.PP
\fIMailkit\fR takes "Kit*" files and sends them to a list of addresses.
The \fB\-n\fR option can be used to change that base name, if necessary.
Each message sent corresponds to one part and has its \`Subject:'
field set to the number of this part with the \fItitle\fR given, and you
also have the total number of parts, so that missing parts can easily
be located.
.PP
The options \fB\-E\fR and \fB\-e\fR from \fImailkit\fR enable you to give
the recipient some instructions. They both call an editor. At the
top of the file edited, there is a little message, which
will (of course) be stripped from the text you enter, so do not
remove it or your own message will be cut instead. With \fB\-E\fR,
the message will be sent in an extra part (#0), while with \fB\-e\fR
it will be included in each part. Empty messages will be ignored.
.PP
When \fImailkit\fR is given a \fB\-l\fR option, it takes the file name
as a file whith recipients addresses in it and adds the optional addresses that
may be given on the command line. Addresses in the recipient file are
separated with spaces, commas or new lines. Shell-style comments starting with
a pound sign (#) are allowed.
.PP
Options \fB\-F\fR and \fB\-f\fR are very similar, but take their
input from stdin (standard input) instead of calling an editor.
Option \fB\-p\fR asks \fImailkit\fR for preserving mailed files. They
are removed by default.
.PP
\fIUnkit\fR is used to restore the original files. The argument is
a list of archive files (or mail files, as \fIunshar\fR(1), which
is called by \fIunkit\fR, can deal with mail headers).
Input files are not removed unless option \fB\-r\fR is given. By default,
option \fB\-p\fR is used to preserve the input file(s).
If no file name is given to \fIunkit\fR, the standard input is processed.
This is useful to process messages directly from a mail user agent.
.PP
If you want to know what \fIunkit\fR will create without actually
doing it, use the \fB\-l\fR option. With this option, \fB\-r\fR is
ignored.
.PP
For all of these commands, option \fB\-V\fR prints the version
number with the current patch level and exits, while \fB\-h\fR gives
a little help message with the syntax and the meaning of the options.
.SH FILES
.PD 0
.TP 20
Kit*
files generated by \fIkit\fR
.TP
{zag,zcb,zec}.hex.*
temporary files used by \fIkit\fR and \fIunkit\fR for datas which
are hex-encoded.
.TP
{zag,zcb,zec}.ba.*
temporary files used by \fIkit\fR and \fIunkit\fR for datas which
are ASCII-encoded.
.TP
zag*
non encrypted files.
.TP
zcb*
data encrypted using CBC mode.
.TP
zec
data encrypted using ECB mode.
.TP
zzz.minikit
file holding the name of the provided minikit script.
.TP
$privlib/minikit
the script which may be used to unkit a distribution when the kit
package is not available.
.PD
.SH NOTE
.PP
In order to use kit, you need to install \fBcshar\fR in your
PATH (programs needed are \fIshar\fR, \fImakekit\fR).
Moreover, \fIhexdecode\fR, \fIhexencode\fR, \fIatob\fR and \fIbtoa\fR
must be installed and \fIcompress\fR must be available.
If any of these is missing, this mailing kit is useless.
.PP
.I Unkit
has its own \fIunshar\fR built-in, but it will not be used if
\fIunshar\fR is installed, because it is really simple-minded and
not smart at all in case of errors. However, this is useful if
you do not have \fBcshar\fR, but still want to use \fIunkit\fR.
.SH EXAMPLES
.PP
To mail \fIram@educ.emse.fr\fR a directory called XLOCK and all what it may
hold, do:
.sp
.in +5
.B kit XLOCK
.br
.B mailkit XLOCK ram@educ.emse.fr
.in -5
.sp
\fIKit\fR will produce files Kit*, and mailkit will send them.
Or, to do it all in one:
.sp
.in +5
.B kit \-m ram@educ.emse.fr XLOCK
.in -5
.sp
If you have no write permissions in the current directory, you can
specify an alternate directory for temporary files:
.sp
.in +5
\fBkit \-m ram@eiffel.com \-d /tmp \-n mykit XLOCK\fR
.in -5
.sp
To unkit, save the mail messages in files called, e.g. xlock.01 (for
part 01), xlock.02 (for part 02) and so on.
Then do:
.sp
.in +5
.B unkit xlock*
.in -5
.sp
Even if it succeeds, files xlock* will not be removed.
.SH BUGS
Try "kit .": it is harmless (well, I hope !), and you will quickly
understand the problem. The solution is to use the \fB\-d\fR option.
.PP
If you use the
.B \-r
option in
.I unkit
and one or more kit parts are missing, all the files will be lost.
So use it with care...
.PP
Some systems cannot extract tar archives with overwriting of ownership
informations (usually this is done with tar option -o).
.SH "SEE ALSO"
atob($manext), btoa($manext), cshar(1), makekit(1).
.SH AUTHOR
Raphael Manfredi <ram@eiffel.com>.

\fIKit\fR was developed at the Ecole des Mines, Saint-Etienne,
France.
!GROK!THIS!
chmod 444 kit.$manext
