.po -3
.TH "Cluster::CalcCols" n "automatically Thu Mar 21 20:11:29 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Cluster::CalcCols \- instance method
.SH TEMPLATE
columns = short
CalcCols()
.SH SPECIFIERS
protected
virtual
.SH DESCRIPTION
\fBCalcCols\fP is called by the \fImethod CalcDimensions\fP and computes the number of columns of \fBthis\fP based on the \fIinstvar align\fP and the number of inner VObjects (see \fImethod CompositeVObject::Size\fP; also referred to as "size" here). The number of rows then automatically results from \fBcolumns\fP (see \fImethod CalcDimensions\fP).
.br
If only horizontal align flags are set, then \fBcolumns\fP is set to \fB1\fP. If only vertical align flags are set, then \fBcolumns\fP is equal to the size. If both horizontal and vertical align flags are set, then the \fBCluster\fP arranges the VObjects in a square layout and therefore \fBcolumns\fP is set to the square root of the size.
.br
By overriding \fBCalcCols\fP it is possible to choose a different calculation or force a specific number of columns. This is done, for example, by the \fImethod Form::CalcCols\fP.
Method is rarely overridden.
.SH ARGUMENTS
none

.SH RETURN ARGUMENT
.TP
\fBshort columns
.br
the computed number of columns of \fBthis\fP. See \fIinstvar cols\fP.
.SH CATEGORIES

.na
overrider interface, implementation
.ad b

.SH FIRST DEFINITION
class Cluster
.SH FILES
.PD 0
.TP 20
implementation:
\fBCluster.C

