.po -3
.TH "Cluster::Cluster" n "automatically Thu Mar 21 20:11:29 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Cluster::Cluster \- instance method
.SH TEMPLATE
void Cluster(int id, VObjAlign align, Point gap, VObject * firstVObject, ellipsis ...)
.SH SPECIFIERS
public
.SH DESCRIPTION
This constructor is usually used when a complete \fBVObject\fP tree is created with a single statement.
.br

.br
For example:
.na
.nf

VObject *layout =
        new Cluster (cIdNone, eVObjHLeft, gPoint8,
                new BorderItem ("TextItems",
                        new Cluster (cIdNone, eVObjVBase, gPoint4,
                                new TextItem ("item1"),
                                new TextItem ("item1"),
                                NULL        // end of list of 2nd Cluster
                        )
                ),
                new Scroller (aView),
                NULL        // end of list of 1st Cluster
        );

.ad b
.fi

.SH ARGUMENTS
.TP
\fBint id
.br
the id of \fBthis\fP
.TP
\fBVObjAlign align
.br
see \fIinstvar align\fP
.TP
\fBPoint gap
.br
see \fIinstvar minGap\fP
.TP
\fBVObject * firstVObject
.br
the first one of the VObjects to be arranged by \fBthis\fP
.TP
\fBellipsis ...
.br
a \fBNULL\fP terminated list with the remaining VObjects to be arranged by \fBthis\fP
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
client interface
.ad b

.SH FILES
.PD 0
.TP 20
implementation:
\fBCluster.C

.po -3
.TH "Cluster::Cluster" n "automatically Thu Mar 21 20:11:29 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Cluster::Cluster \- instance method
.SH TEMPLATE
void Cluster(int id, VObjAlign align = eVObjVBase, Point gap = gPoint0, Collection * arrangedVObjects = NULL)
.SH SPECIFIERS
public
.SH DESCRIPTION
This constructor can be used if a collection of VObjects already exists or if the VObjects are added later.
.br

.br
For example:
.na
.nf

Collection *items = new OrdCollection;
items-\>Add (new TextItem ("item1"));
items-\>Add (new TextItem ("item2"));
Cluster *cl = new Cluster (cIdNone, eVObjHLeft, gPoint8, items);

// Adding the VObjects later:

Cluster *cl = new Cluster (cIdNone, eVObjHLeft, gPoint8, NULL);
cl-\>Add (new TextItem ("item1"));
cl-\>Add (new TextItem ("item2"));

.ad b
.fi

.SH ARGUMENTS
.TP
\fBint id
.br
the id of \fBthis\fP
.TP
\fBVObjAlign align = eVObjVBase
.br
see \fIinstvar align\fP
.TP
\fBPoint gap = gPoint0
.br
see \fIinstvar minGap\fP
.TP
\fBCollection * arrangedVObjects = NULL
.br
the VObjects to be arranged by \fBthis\fP
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
client interface
.ad b

.SH FILES
.PD 0
.TP 20
implementation:
\fBCluster.C

.po -3
.TH "Cluster::Cluster" n "automatically Thu Mar 21 20:11:29 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Cluster::Cluster \- instance method
.SH TEMPLATE
void Cluster(int id, VObjAlign align, Point gap, va_list arrangedVObjects)
.SH SPECIFIERS
public
.SH DESCRIPTION
This constructor can be used if a function or method gets a variable number of VObject arguments.
.br

.br
For example:
.na
.nf

// at least one non-VObject argument is required
// the macro "va_" hides machine dependencies

VObject *MyClass::DoMakeLayout (Point va_(gap), ...)
{
        va_list ap;
        va_start(ap, va_(gap));
        // "ap" now points to first VObject
        VObject *layout = new Cluster (cIdNone, eVObjHLeft, va_(gap), ap);
        va_end(ap);
        return layout; 
}

void MyClass::AnotherMethod()
{
        VObject *layout = DoMakeLayout (gPoint4,
                                        new TextItem("item1"),
                                        new TextItem("item2"),
                                        new TextItem("item3"),
                                        NULL);
}

.ad b
.fi

.SH ARGUMENTS
.TP
\fBint id
.br
the id of \fBthis\fP
.TP
\fBVObjAlign align
.br
see \fIinstvar align\fP
.TP
\fBPoint gap
.br
see \fIinstvar minGap\fP
.TP
\fBva_list arrangedVObjects
.br
refers to a \fBNULL\fP terminated list with the VObjects to be arranged by \fBthis\fP
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
client interface
.ad b

.SH FILES
.PD 0
.TP 20
implementation:
\fBCluster.C

