.po -3
.TH "Cluster::SetExtent" n "automatically Thu Mar 21 20:11:29 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Cluster::SetExtent \- instance method
.SH TEMPLATE
see template of VObject::SetExtent
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
\fBSetExtent\fP sets the extent of \fBthis\fP and calculates the extent of all inner VObjects.
Method is rarely overridden.
Method always calls base method.
.SH ARGUMENTS
see arguments of VObject::SetExtent
.SH RETURN ARGUMENT
see return argument of VObject::SetExtent
.SH CATEGORIES

.na
implementation
.ad b

.SH FIRST DEFINITION
class VObject
.SH FILES
.PD 0
.TP 20
implementation:
\fBCluster.C

.SH KNOWN PROBLEMS

1. \fBSetExtent\fP increments the \fBbase\fP component of the \fIinstvar minsize\fP to adjust the overall baseline according to the actual height of the \fBCluster\fP. This is OK if the layout is calculated the first time. But on subsequent invocations, when the \fImethod GetMinSize\fP does no longer recalculate the \fIinstvar minsize\fP, the baseline is incremented again and again. This error can be seen if a \fBCluster\fP is installed in a horizontal \fBExpander\fP (such an \fBExpander\fP aligns at the baseline) and the window is resized several times.
.br
A solution would be to save the initial value of the baseline in a separate variable and update the baseline in \fBSetExtent\fP based on the value of that variable.
.br

.br
2. If an expand flag is set (\fBeVObjHExpand\fP or \fBeVObjVExpand\fP), then \fBSetExtent\fP always expands the inner VObjects without checking their fixed flags (\fBeVObjHFixed\fP or \fBeVObjVFixed\fP).
.br
If this error would be fixed, the functionality of the Expander would be fully provided by the Cluster.
