.po -3
.TH "Collection::Remove" n "automatically Fri Mar  1 10:57:30 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Collection::Remove \- instance method
.SH TEMPLATE
removedObject = ObjPtr
Remove(ObjPtr anObject)
.SH SPECIFIERS
public
abstract
virtual
.SH DESCRIPTION
Attempts to remove an element from the receiver which is equal to \fBanObject\fP in the sense of @Object::IsEqual. If there has been such an
element, Remove returns it, otherwise 0 is returned.
.br
In SeqCollections, the element with the least index is removed if more
than one element is equal to anObject.
.br
A succesful Remove operation sends the default change message.
See also \fImethod RemovePtr\fP and \fImethod RemoveAll\fP.
Method is often overridden.
.SH ARGUMENTS
.TP
\fBObjPtr anObject
.br
Object to be removed.
.SH RETURN ARGUMENT
.TP
\fBObjPtr removedObject
.SH CATEGORIES

.na
manipulation, client interface, overrider interface
.ad b

.SH FIRST DEFINITION
class Collection
.SH FILES
.PD 0
.TP 20
implementation:
\fBCollection.C

.SH KNOWN PROBLEMS

It is undefined wether the IsEqual operation is invoked on anObject or on
some elements of the receiver.
.br
Some implementations do send no change message at all.
