.po -3
.TH "Collection::RemoveAll" n "automatically Fri Mar  1 10:57:30 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Collection::RemoveAll \- instance method
.SH TEMPLATE
void RemoveAll(CollPtr elementsToBeRemoved)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
Attempts to remove all elements of elementsToBeRemoved from the
receiver.
.br
RemoveAll is based on \fImethod Remove\fP. The order of the elements to be
removed is determined by the iterator returned by MakeIterator of
elementsToBeRemoved.
.br
A RemoveAll sends the default change message one time if the size of the
receiver has changed. 
See also \fImethod AddAll\fP and \fImethod FreeAll\fP.
.br
RemoveAll is declared virtual for provision of more efficient
implementations.
.br
Hint: Comparing the receiver's Size before and after a RemoveAll operation
might be interesting in some cases.
Method is rarely overridden.
.SH ARGUMENTS
.TP
\fBCollPtr elementsToBeRemoved
.br
A collection whose elements are to be removed from the receiver.
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
manipulation, client interface
.ad b

.SH FIRST DEFINITION
class Collection
.SH FILES
.PD 0
.TP 20
implementation:
\fBCollection.C

.SH KNOWN PROBLEMS

There is no comparable operation that is based on RemovePtr.
.br
It depends on the implementation of Remove, wether change message are sent.
If they do, they do it for each succesful Remove operation. This is neither
correct.
