.po -3
.TH "Collection::RemovePtr" n "automatically Fri Mar  1 10:57:30 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Collection::RemovePtr \- instance method
.SH TEMPLATE
removedObject = ObjPtr
RemovePtr(ObjPtr anObject)
.SH SPECIFIERS
public
abstract
virtual
.SH DESCRIPTION
Removes an element from the receiver which is identical to anObject
(in the sense of pointer equality). If the attempt to remove anObject is
succesful, RemovePtr returns the removed object, otherwise 0.
.br
In SeqCollections, the element with the least index is removed if there is
more than one element identical to anObject.
.br
A succesful RemovePtr operation sends the default change message.
.br
See also \fImethod Remove\fP and \fImethod RemoveAll\fP.
Method is always overridden.
.SH ARGUMENTS
.TP
\fBObjPtr anObject
.br
Object to be removed.
.SH RETURN ARGUMENT
.TP
\fBObjPtr removedObject
.SH CATEGORIES

.na
manipulation, client interface, overrider interface
.ad b

.SH FIRST DEFINITION
class Collection
.SH FILES
.PD 0
.TP 20
implementation:
\fBCollection.C

.SH KNOWN PROBLEMS

Some implementations of RemovePtr do send no change message at all.
