.po -3
.TH "Collection::Select" n "automatically Fri Mar  1 10:57:30 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Collection::Select \- instance method
.SH TEMPLATE
aCollection = CollPtr
Select(BoolFun selectingFunction, void * anArgument)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
Returns a collection of the same class as the receiver. The returned
collection has been added all elements of the receiver for which
selectionFunction has evaluated to TRUE.
.br
The order of passing elements to selectionFunction is the same as the order
produced by the standard iterator returned by MakeIterator.
.br
See also \fImethod Collect\fP.
Method is rarely overridden.
.SH ARGUMENTS
.TP
\fBBoolFun selectingFunction
.br
The meaning of the arguments of \fBselectingFunction\fP is 
.na
.nf
(ObjPtr
theReceiver, ObjPtr anElementOfTheReceiver, void *anArgument)
.ad b
.fi
.
.TP
\fBvoid * anArgument
.br
Argument passed to \fBselectingFunction\fP on every evaluation. It
describes the context of the Select invocation. Type and semantics depend
on the actual function selectionFunction points to. Select itself does not
take care of anArgument.
.SH RETURN ARGUMENT
.TP
\fBCollPtr aCollection
.SH CATEGORIES

.na
enumeration, client interface
.ad b

.SH FIRST DEFINITION
class Collection
.SH FILES
.PD 0
.TP 20
implementation:
\fBCollection.C

