.po -3
.TH "CollectionView::DoSelect" n "automatically Mon Apr  8 20:18:15 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
CollectionView::DoSelect \- instance method
.SH TEMPLATE
void DoSelect(Rectangle selection, int clicks)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
\fBDoSelect\fP is called by the \fImethod DoSelect2\fP when the \fBCellSelector\fP created by the \fImethod DoLeftButtonDownCommand\fP has finished and at least one cell has been selected. By default, it notifies the next handlers through the \fImethod Control\fP by sending the id of \fBthis\fP, either \fIconst cPartCollDoubleSelect\fP or \fIconst cPartCollSelect\fP as part code and the row number of the selected cell.
.br
Clients that wish to be informed about selection events have two possibilities:
.br
1. install themselves as next event handler of a \fBCollectionView\fP and override the \fImethod Control\fP
.br
2. directly override \fBDoSelect\fP, check the \fBselection\fP and react appropriately.
Method is sometimes overridden.
.SH ARGUMENTS
.TP
\fBRectangle selection
.br
see \fIinstvar selection\fP
.TP
\fBint clicks
.br
specifies whether cells have been selected with a single or double click. If \fBclicks\fP is greater than 1, then the next handlers are notified with \fBcPartCollDoubleSelect\fP, otherwise with \fBcPartCollSelect\fP.
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
selection, overrider interface, implementation
.ad b

.SH FIRST DEFINITION
class CollectionView
.SH FILES
.PD 0
.TP 20
implementation:
\fBCollView.C

.SH KNOWN PROBLEMS

\fBDoSelect\fP passes only the row number of the selected cell (\fBselection.origin.y\fP) to \fBControl\fP. It should rather send a reference to \fBselection\fP.
