.po -3
.TH "CompositeVObject::CompositeVObject" n "automatically Thu Mar 21 20:11:40 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
CompositeVObject::CompositeVObject \- instance method
.SH TEMPLATE
void CompositeVObject(int id, ellipsis ...)
.SH SPECIFIERS
public
.SH DESCRIPTION
This constructor cannot be used by subclasses because in C++ it is impossible to pass a variable number of arguments to another method. But it can be used to \fBcreate instances\fP. For example:
.na
.nf

CompositeVObject *cvop =
        new CompositeVObject (cIdNone,
                new TextItem ("item1"),
                new TextItem ("item2"),
                NULL
        );

.ad b
.fi

.SH ARGUMENTS
.TP
\fBint id
.br
the id of \fBthis\fP
.TP
\fBellipsis ...
.br
a \fBNULL\fP terminated list with the inner VObjects of \fBthis\fP
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
client interface
.ad b

.SH FILES
.PD 0
.TP 20
implementation:
\fBVObject.C

.po -3
.TH "CompositeVObject::CompositeVObject" n "automatically Thu Mar 21 20:11:40 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
CompositeVObject::CompositeVObject \- instance method
.SH TEMPLATE
void CompositeVObject(int id = cIdNone, Collection * innerVObjects = NULL)
.SH SPECIFIERS
public
.SH DESCRIPTION
This constructor is often used by subclasses which either have a similar constructor or set \fBinnerVObjects\fP to \fBNULL\fP and add the inner VObjects themselves. See the \fIclass Cluster\fP for an example.
.SH ARGUMENTS
.TP
\fBint id = cIdNone
.br
the id of \fBthis\fP
.TP
\fBCollection * innerVObjects = NULL
.br
the inner VObjects of \fBthis\fP
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
overrider interface
.ad b

.SH FILES
.PD 0
.TP 20
implementation:
\fBVObject.C

.po -3
.TH "CompositeVObject::CompositeVObject" n "automatically Thu Mar 21 20:11:40 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
CompositeVObject::CompositeVObject \- instance method
.SH TEMPLATE
void CompositeVObject(int id, va_list innerVObjects)
.SH SPECIFIERS
public
.SH DESCRIPTION
This constructor is used by subclasses which have a similar constructor. See the \fIclass Cluster\fP for an example.
.SH ARGUMENTS
.TP
\fBint id
.br
the id of \fBthis\fP
.TP
\fBva_list innerVObjects
.br
refers to a \fBNULL\fP terminated list with the inner VObjects of \fBthis\fP
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
overrider interface
.ad b

.SH FILES
.PD 0
.TP 20
implementation:
\fBVObject.C

