.po -3
.TH "CompositeVObject::SetAt" n "automatically Thu Mar 21 20:11:40 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
CompositeVObject::SetAt \- instance method
.SH TEMPLATE
oldItem = VObject *
SetAt(int index, VObject * newItem)
.SH SPECIFIERS
public
.SH DESCRIPTION
\fBSetAt\fP replaces the \fBoldItem\fP at \fBindex\fP with the \fBnewItem\fP, recalculates the layout of \fBthis\fP and returns the \fBoldItem\fP. If the \fIinstvar list\fP does not contain an item at \fBindex\fP, then \fBNULL\fP is returned and the \fBnewItem\fP is added at the end of the \fIinstvar list\fP.
.SH ARGUMENTS
.TP
\fBint index
.br
the index of the item which is replaced by the \fBnewItem\fP
.TP
\fBVObject * newItem
.br
an item which replaces the one at \fBindex\fP
.SH RETURN ARGUMENT
.TP
\fBVObject * oldItem
.br
the item which has been replaced with the \fBnewItem\fP or \fBNULL\fP if there is no VObject at \fBindex\fP in the \fIinstvar list\fP
.SH CATEGORIES

.na
collection, client interface
.ad b

.SH FILES
.PD 0
.TP 20
implementation:
\fBVObject.C

.SH KNOWN PROBLEMS

1. \fBSetAt\fP does not call \fBGetMinSize\fP before \fBSetExtent\fP. But this is necessary for layout recalculation.
.br
2. It does not call \fBSetModified\fP.
