.po -3
.TH "DialogView::Control" n "automatically Fri Mar 15 14:08:52 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
DialogView::Control \- instance method
.SH TEMPLATE
see template of EvtHandler::Control
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
\fBControl\fP is called whenever an action is performed on a dialog item, e.g. when a button is selected. The \fBid\fP contains the id of the dialog item, the \fBpart\fP identifies the performed action and \fBvalue\fP contains additional information.
.br
Clients have to override \fBControl\fP in order to handle events from the dialog items created in the \fImethod DoCreateDialog\fP. After these events have been processed \fBControl\fP should always call the inherited method which distributes the keyboard focus and recalculates the dialog layout when necessary.
.br
Examples can be found in the \fImethod ChangeDialog::Control\fP and the \fImethod FileDialog::Control\fP.
Method is often overridden.
Method always calls base method.
.SH ARGUMENTS
see arguments of EvtHandler::Control
.SH RETURN ARGUMENT
see return argument of EvtHandler::Control
.SH CATEGORIES

.na
overrider interface
.ad b

.SH FIRST DEFINITION
class EvtHandler
.SH FILES
.PD 0
.TP 20
implementation:
\fBDialog.C

