.po -3
.TH "DialogView::SetDialog" n "automatically Fri Mar 15 14:08:52 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
DialogView::SetDialog \- instance method
.SH TEMPLATE
oldDialogTree = VObject *
SetDialog(VObject * newDialogTree, bool redraw = TRUE)
.SH SPECIFIERS
public
.SH DESCRIPTION
\fBSetDialog\fP installs the \fBnewDialogTree\fP and returns the \fBoldDialogTree\fP, the \fIinstvar dialogRoot\fP. The whole \fBnewDialogTree\fP is initialized and the layout is recalculated.
.br
\fBSetDialog\fP is called by the \fImethod Update\fP with the dialog tree returned by the \fImethod DoCreateDialog\fP before \fBthis\fP is drawn the first time. But it may also be called by the client, e.g., to switch between several dialog trees at runtime. \fBSetDialog\fP is used, for example, by the \fImethod TreeView::SetTree\fP.
.SH ARGUMENTS
.TP
\fBVObject * newDialogTree
.br
the new dialog tree for \fBthis\fP
.TP
\fBbool redraw = TRUE
.br
indicates whether to invalidate the content rectangle of \fBthis\fP after the \fBnewDialogTree\fP has been set. \fBredraw\fP is passed to the \fImethod CalcLayout\fP.
.SH RETURN ARGUMENT
.TP
\fBVObject * oldDialogTree
.br
the old dialog tree of \fBthis\fP. See \fIinstvar dialogRoot\fP.
.SH CATEGORIES

.na
implementation
.ad b

.SH FILES
.PD 0
.TP 20
implementation:
\fBDialog.C

.SH KNOWN PROBLEMS

Before setting the \fBnewDialogTree\fP \fBSetDialog\fP neither empties the \fIinstvar kbdFocusItems\fP nor clears the \fIinstvar kbdFocus\fP and the \fIinstvar defaultButton\fP. This doesn't matter if the dialog tree is never replaced but it may cause errors if a client explicitly sets a new dialog layout at runtime.
