.po -3
.TH "Document::CanImportDocument" n "automatically Fri Mar 15 14:13:05 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Document::CanImportDocument \- instance method
.SH TEMPLATE
canImport = bool
CanImportDocument(FileType * type)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
\fBCanImportDocument\fP serves two purposes: if \fBtype\fP is \fBNULL\fP it must return whether the document can import data at all. This is used to find out whether the "file" submenu of the document's menu should contain an "import ..." item. If \fBtype\fP is specified \fBCanImportDocument\fP must return whether the document can import data from documents of the specified type. The default implementation always returns \fBFALSE\fP.
.br
If you override this method you must also override \fImethod DoImport\fP which actually has to do the work.
.br
See also \fImethod CanLoadDocument\fP.
Method is sometimes overridden.
.SH ARGUMENTS
.TP
\fBFileType * type
.br
the type of the document to be imported or \fBNULL\fP
.SH RETURN ARGUMENT
.TP
\fBbool canImport
.br
indicates whether the document can import data from documents of the specified type or, if \fBtype\fP is \fBNULL\fP, whether it can import data at all
.SH CATEGORIES

.na
input/output, overrider interface
.ad b

.SH FIRST DEFINITION
class Document
.SH FILES
.PD 0
.TP 20
implementation:
\fBDocument.C

