.po -3
.TH "Document::DoFileIsAlreadyOpen" n "automatically Fri Mar 15 14:13:05 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Document::DoFileIsAlreadyOpen \- instance method
.SH TEMPLATE
openFileOnceMore = bool
DoFileIsAlreadyOpen(Document * anotherDoc, char * fileName)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
\fBDoFileIsAlreadyOpen\fP is called by the \fImethod Load\fP when a file is to be loaded which has already been opened by \fBanotherDoc\fP. \fBDoFileIsAlreadyOpen\fP must tell now whether this document may also open the file.
.br
The default implementation pops up an alert with a warning message, calls the \fImethod ShowDocument\fP and returns \fBFALSE\fP. The \fImethod ShowDocument\fP puts the main window of \fBanotherDoc\fP in front of all the other windows.
.br
Override this method and return \fBTRUE\fP if it is allowed to open a file several times within an application.
.br
See also the \fBfilebrowserII\fP example application which allows to edit the same file in different windows concurrently.
Method is rarely overridden.
.SH ARGUMENTS
.TP
\fBDocument * anotherDoc
.br
the document which already has opened the file
.TP
\fBchar * fileName
.br
the name of the file already opened by \fBanotherDoc\fP
.SH RETURN ARGUMENT
.TP
\fBbool openFileOnceMore
.br
indicates whether this document may open the file, too
.SH CATEGORIES

.na
input/output, overrider interface
.ad b

.SH FIRST DEFINITION
class Document
.SH FILES
.PD 0
.TP 20
implementation:
\fBDocument.C

