.po -3
.TH "EvtHandler::Control" n "automatically Fri Mar 15 14:09:27 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
EvtHandler::Control \- instance method
.SH TEMPLATE
void Control(int id, int part, void * value)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
\fBControl\fP is called on events generated by VObjects or other EvtHandlers (e.g., when a button is selected; see also \fImethod Button::DoOnItem\fP). \fBControl\fP is often overridden by subclasses of the \fIclass Dialog\fP in order to "control", i.e. react to the selection of a dialog item (e.g. the \fImethod FindDialog::Control\fP). The default implementation passes the events to the next handler.
.br
Compare this with the \fImethod SendDown\fP and the \fImethod Object::Send\fP.
Method is often overridden.
.SH ARGUMENTS
.TP
\fBint id
.br
the id of a certain object or event
.TP
\fBint part
.br
a code that describes the event more detailed
.TP
\fBvoid * value
.br
an optional argument whose exact type must be determined by the values of \fBid\fP and \fBpart\fP
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
event handling, overrider interface
.ad b

.SH FIRST DEFINITION
class EvtHandler
.SH FILES
.PD 0
.TP 20
implementation:
\fBEvtHandler.C

