.po -3
.TH "EvtHandler::FindNextHandlerOfClass" n "automatically Fri Mar 15 14:09:27 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
EvtHandler::FindNextHandlerOfClass \- instance method
.SH TEMPLATE
aNextHandler = EvtHandler *
FindNextHandlerOfClass(Class * desiredClass)
.SH SPECIFIERS
public
.SH DESCRIPTION
\fBFindNextHandlerOfClass\fP follows the event handler chain and returns the first handler which \fBIsKindOf\fP the \fBdesiredClass\fP (see the \fImacro IsKindOf\fP). If there is no such handler \fBNULL\fP is returned. \fBFindNextHandlerOfClass\fP is used, for example, by the \fImethod View::GetDocument\fP.
.br
Compare this method with the \fImethod VObject::FindContainerOfClass\fP.
.SH ARGUMENTS
.TP
\fBClass * desiredClass
.br
the desired class of the searched handler. Classes can be specified with the \fImacro Meta\fP, e.g. \fBMeta(Document)\fP.
.SH RETURN ARGUMENT
.TP
\fBEvtHandler * aNextHandler
.br
the first event handler in the chain which is kind of the \fBdesiredClass\fP or \fBNULL\fP
.SH CATEGORIES

.na
metaclass, client interface
.ad b

.SH FILES
.PD 0
.TP 20
implementation:
\fBEvtHandler.C

.SH KNOWN PROBLEMS

Testing starts with \fBthis\fP and not directly with the next handler. For example, if \fBthis\fP is a \fBView\fP, then \fBFindNextHandlerOfClass(Meta(View))\fP again returns \fBthis\fP. A workaround is to start the search directly with the next handler:
.na
.nf

View *nextView = NULL;
if (GetNextHandler())
    nextView = (View*)GetNextHandler()-\>FindNextHandlerOfClass(Meta(View));

.ad b
.fi

