.po -3
.TH "EvtHandler::PerformCommand" n "automatically Fri Mar 15 14:09:27 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
EvtHandler::PerformCommand \- instance method
.SH TEMPLATE
void PerformCommand(Command * commandToExecute)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
\fBPerformCommand\fP is called for commands returned by the \fBDo...Command\fP methods of \fBEvtHandler\fP or the \fIclass VObject\fP, such as the \fImethod DoMenuCommand\fP or the \fImethod VObject::DoLeftButtonDownCommand\fP.
.br
Commands are passed along the event handler chain until the end of the chain is reached or an \fBEvtHandler\fP has overridden \fBPerformCommand\fP and executes the command. Commands are usually executed by instances of the \fIclass Document\fP (see \fImethod Document::PerformCommand\fP). If there is neither a \fBDocument\fP nor another command performer in the event handler chain, then the command is executed and immediately committed which means it cannot be undone. See also the \fIclass Command\fP.
Method is rarely overridden.
.SH ARGUMENTS
.TP
\fBCommand * commandToExecute
.br
is the command object to be executed. The command \fIvar gNoChanges\fP can be ignored. The command \fIvar gResetUndo\fP must not be executed because it only tells the command performer to reset the undo/redo mechanism. This happens, for example, whenever a document is saved (see the \fImethod Document::Save\fP and the \fImethod Document::PerformCommand\fP).
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
commands, overrider interface
.ad b

.SH FIRST DEFINITION
class EvtHandler
.SH FILES
.PD 0
.TP 20
implementation:
\fBEvtHandler.C

