.po -3
.TH "ImageItem::ImageItem" n "automatically Fri Mar 15 14:10:52 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
ImageItem::ImageItem \- instance method
.SH TEMPLATE
void ImageItem(short * bitmapData, Point bitmapSize, int base = 0)
.SH SPECIFIERS
public
.SH DESCRIPTION
This constructor automatically creates the bitmap from the supplied data. The destructor will delete the bitmap. Example:
.na
.nf

static u_short iconImage[] = {
#include "Icon.image"		// image file created by icon editor 
};

ImageItem *icon = new ImageItem(iconImage, Point(32,32), 24);

.ad b
.fi

.SH ARGUMENTS
.TP
\fBshort * bitmapData
.br
an array containing the bitmap data
.TP
\fBPoint bitmapSize
.br
the size of the bitmap in pixels. The size must exactly match the real extent of the bitmap contained in \fBbitmapData\fP.
.TP
\fBint base = 0
.br
see \fIinstvar base\fP
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
client interface
.ad b

.SH FILES
.PD 0
.TP 20
implementation:
\fBImageItem.C

.po -3
.TH "ImageItem::ImageItem" n "automatically Fri Mar 15 14:10:52 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
ImageItem::ImageItem \- instance method
.SH TEMPLATE
void ImageItem(Bitmap * bitmap, int base = 0)
.SH SPECIFIERS
public
.SH DESCRIPTION
This constructor expects a bitmap created by the client. The destructor will not delete it. Example:
.na
.nf

static u_short iconImage[] = {
#include "Icon.image"		// image file created by icon editor 
};

Bitmap *bitmap = new Bitmap(Point(32,32), iconImage);
ImageItem *icon = new ImageItem(bitmap, 24);

.ad b
.fi
Also possible:
.na
.nf

ImageItem *icon = new ImageItem(new Bitmap("Icon.image"), 24);

.ad b
.fi

.SH ARGUMENTS
.TP
\fBBitmap * bitmap
.br
a client supplied bitmap. See the example.
.TP
\fBint base = 0
.br
see \fIinstvar base\fP
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
client interface
.ad b

.SH FILES
.PD 0
.TP 20
implementation:
\fBImageItem.C

.po -3
.TH "ImageItem::ImageItem" n "automatically Fri Mar 15 14:10:52 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
ImageItem::ImageItem \- instance method
.SH TEMPLATE
void ImageItem(int id, Bitmap * bitmap, int base = 0)
.SH SPECIFIERS
public
.SH DESCRIPTION
See the constructor \fBImageItem(Bitmap *, int)\fP.
.SH ARGUMENTS
.TP
\fBint id
.br
the id of the \fBImageItem\fP
.TP
\fBBitmap * bitmap
.br
a client supplied bitmap
.TP
\fBint base = 0
.br
see \fIinstvar base\fP
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
client interface
.ad b

.SH FILES
.PD 0
.TP 20
implementation:
\fBImageItem.C

