.po -3
.TH "Object::AddObserver" n "automatically Fri Mar 1 10:54:57 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Object::AddObserver \- instance method
.SH TEMPLATE
void AddObserver(ObjPtr aNewObserver)
.SH SPECIFIERS
public
.SH DESCRIPTION
Registers \fBaNewObserver\fP as an observer of the receiver. Since
it is meaningless to register an object as an observer more than once,
doing so results in a warning.
.br
An observer is unregistered via \fImethod RemoveObserver\fP.
.br
Remarks:
.br
 
(1) In general, an object is registered as an observer by itself, but
rarely by another object.
.br
(2) It would be more consistent (e.g. Collection's interface) and more
convenient to return aNewObserver if the registration has not taken place
(since the object has already been there), so the client code could detect
it more easily if that is necessary. Up to now, determining wether an
object is already registered, is only possible using \fImethod
GetObserverIter\fP.
.SH ARGUMENTS
.TP
\fBObjPtr aNewObserver
.br
an object to be registered as an observer of the receiver
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
change propagation, client interface
.ad b

.SH FILES
.PD 0
.TP 20
implementation:
\fBObject.C

