.po -3
.TH "Object::DoError" n "automatically Fri Mar 1 10:54:57 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Object::DoError \- instance method
.SH TEMPLATE
void DoError(int errorLevel, char * location, char * messageFormat, va_list formatArguments)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
Prepends the class name to the \fBlocation\fP and invokes the currently
installed global error handler (\fIfunction ErrorHandler\fP) to display
the error message.
.br
There is no need to call DoError directly, since for the most common
error categories, there are already methods acting as entry points like \fImethod Warning\fP, \fImethod Error\fP, \fImethod SysError\fP and \fImethod Fatal\fP.
.br
As a good programming practice, the client should add an further entry
point in form a method (e.g. like \fBWarning\fP) if a new error category
shall be introduced. This makes the code more expressive, and localizes the
actions.
.br
The \fIfunction ErrorHandler\fP prints the error message on the
standard error output and additionally pops up an alert window. By
overriding DoError this behavior can be customized for a specific class.
Use the \fIfunction SetErrorHandler\fP to replace the global error
handler.
.br
See \fItechnote 'Error Handling'\fP.
Method is rarely overridden.
.SH ARGUMENTS
.TP
\fBint errorLevel
.br
indicates the severeness of the error and depends on who called this
method. It is either \fIconst cWarning\fP, \fIconst cError\fP, \fIconst cSysError\fP or \fIconst cFatal\fP.
.TP
\fBchar * location
.br
the (unqualified) name of the method where the error occurred
.TP
\fBchar * messageFormat
.br
a string with the format of the error message in the style of the standard
C and C++ function \fBprintf\fP
.TP
\fBva_list formatArguments
.br
actual arguments corresponding to the formal arguments mentioned in \fBmessageFormat\fP (like the C and C++ function \fBprintf\fP)
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
error handling, overrider interface
.ad b

.SH FIRST DEFINITION
class Object
.SH FILES
.PD 0
.TP 20
implementation:
\fBObject.C

