.po -3
.TH "Object::GetAddrOf" n "automatically Fri Mar 1 10:54:57 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Object::GetAddrOf \- instance method
.SH TEMPLATE
address = void *
GetAddrOf(const char * instanceVariable, Class *& metaClass)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
This method provides \fBunchecked access to instance variables\fP of
an object. It returns the memory address of the value of the \fBinstanceVariable\fP of this object so that the value can directly be accessed
or modified.
.br
GetAddrOf walks up the class hierarchy until it finds
an entry for the \fBinstanceVariable\fP in a metaclass. It returns the memory
address of the \fBinstanceVariable\fP and in \fBmetaClass\fP a reference to
the associated metaclass. This means that private or protected instance
variables can also be accessed and even modified !
.br
GetAddrOf works only for instance variables listed in the \fImacro
MetaImpl\fP for that class.
.br
See \fItechnote Metaclasses\fP.
.br

.br

.br
.B Notice:

Method is never overridden.
.SH ARGUMENTS
.TP
\fBconst char * instanceVariable
.br
the name of an instance variable of the receiver
.TP
\fBClass *& metaClass
.br
returns a reference to the associated class descriptor of the \fBinstanceVariable\fP. If the \fBinstanceVariable\fP could not be found, then
\fBmetaClass\fP remains unchanged.
.SH RETURN ARGUMENT
.TP
\fBvoid * address
.br
the address of the value of the \fBinstanceVariable\fP of this object or
\fBNULL\fP if the \fBinstanceVariable\fP could not be found.
.br
The \fBaddress\fP must be casted to a pointer to the actual type of the
instance variable. For example, if the type of the \fBinstanceVariable\fP
is \fBObject *\fP then \fBaddress\fP must be casted to \fBObject **\fP.
.SH CATEGORIES

.na
metaclass, client interface
.ad b

.SH FIRST DEFINITION
class Object
.SH FILES
.PD 0
.TP 20
implementation:
\fBObject.C

