.po -3
.TH "Object::Hash" n "automatically Fri Mar 1 10:54:57 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Object::Hash \- instance method
.SH TEMPLATE
hashValue = u_long
Hash()
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
This method returns an appropriate hash value for the receiver. Different
objects may return the same hash value, but if two objects are equal
according to \fImethod IsEqual\fP, they \fBmust\fP return the same
hash value.
.br
Hash is used by the \fIclass Set\fP, for instance, that implements a
particular hashing algorithm.
.br

.br
Object's implementation uses only the pointer value of \fBthis\fP to
calculate the hash value.
.br

Examples how to calculate appropriate hash values can be found in the \fImethod ByteArray::Hash\fP or the \fImethod Collection::Hash\fP.
Method is often overridden.
.SH ARGUMENTS
none

.SH RETURN ARGUMENT
.TP
\fBu_long hashValue
.br
a hash value for the object
.SH CATEGORIES

.na
comparison, collection support, client
interface, overrider interface
.ad b

.SH FIRST DEFINITION
class Object
.SH FILES
.PD 0
.TP 20
implementation:
\fBObject.C

.SH KNOWN PROBLEMS

See \fImethod IsEqual\fP.
