.po -3
.TH "Object::InspectorId" n "automatically Fri Mar 1 10:54:57 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Object::InspectorId \- instance method
.SH TEMPLATE
void InspectorId(char * displayedName, int maxSize)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
InspectorId sets displayedName to a value that will eventually be
displayed by the tools of the Programming Environment as an additional
information when presenting the receiver to the user, e.g. in a list box of
the Inspector.  Objects of the same class can therefore be easily
identified by the user, provided the displayedName's are meaningful.
.br
The default implementation sets displayedName to "". There is no need to
override this method (but it is a good good idea).
.br

See \fImethod Document::InspectorId\fP, \fImethod
TextItem::InspectorId\fP, \fImethod Collection::InspectorId\fP for
interesting examples.
Method is often overridden.
.SH ARGUMENTS
.TP
\fBchar * displayedName
.br
a null-terminated string
.TP
\fBint maxSize
.br
the available number of characters in \fBdisplayedName\fP inclusive the
terminating zero character
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
progenv support, overrider interface
.ad b

.SH FIRST DEFINITION
class Object
.SH FILES
.PD 0
.TP 20
implementation:
\fBObject.C

