.po -3
.TH "Object::PrintOnWhenObserved" n "automatically Fri Mar 1 10:54:57 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Object::PrintOnWhenObserved \- instance method
.SH TEMPLATE
printThisObserverToo = bool
PrintOnWhenObserved(ObjPtr anObservedObject)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
The \fImethod Object::PrintOn\fP invokes this operation on each
observer of anObservedObject to determine whether this particular observer shall
also be printed when the observed object is output by PrintOn (see also
\fItechnote 'Change Propagation'\fP and \fItechnote 'Object
Input/Output'\fP).
.br
Objects that have observers not to be output for some reasons have this
method overridden accordingly. In general, such observers will exist
and will be registered anyway, when the observed object gets
working. This is the case, for instance, for the application object.
It may also considerably save space not to output such objects.
.br
Object's implementation returns \fBTRUE\fP.
.br
For example, the \fImethod TextView::PrintOnWhenObserved\fP returns
\fBFALSE\fP if the observed object is the displayed text.
Method is rarely overridden.
.SH ARGUMENTS
.TP
\fBObjPtr anObservedObject
.br
an object which is observed by the receiver
.SH RETURN ARGUMENT
.TP
\fBbool printThisObserverToo
.br
specifies whether \fBthis\fP should also
be printed by the \fImethod Object::PrintOn\fP
.SH CATEGORIES

.na
object i/o, change propagation, overrider interface
.ad b

.SH FIRST DEFINITION
class Object
.SH FILES
.PD 0
.TP 20
implementation:
\fBObject.C

.SH KNOWN PROBLEMS

The name \fBPrintOnWhenObserved\fP is misleading because it suggests that
the receiver is observed. A better name is 
.na
.nf
PrintOnWhenObserving
(ObjPtr theObserved)
.ad b
.fi
. That will be fixed in future versions.
