.po -3
.nh
.TH "OnOffItem" n "automatically Thu Mar 21 20:12:50 1991" "ET++ version v2.2" "ET++ class description"
.SH NAME
OnOffItem.short \- a two-state button with graphic images
.SH DESCRIPTION
The \fBOnOffItem\fP implements a two-state button with user-definable bitmaps. The bitmaps are drawn if the state of the button is on, respectively off.
.br
The \fBOnOffItem\fP sends its id, the part code \fBcPartToggle\fP and its current state via \fBControl\fP to its next event handlers when it is selected. An \fBOnOffItem\fP may also be controlled by an \fBEnumItem\fP.
.br
There are also two subclasses, the \fIclass RadioButton\fP and the \fIclass ToggleButton\fP, that implement buttons with fixed bitmaps.

.br
classes are rarely derived from \fBOnOffItem\fP.
.br
class \fBOnOffItem\fP
is sometimes reused directly.
.br
class \fBOnOffItem\fP is abstract.
.br
class \fBOnOffItem\fP contains 10 methods.
.PD 0
.TP 20
\fBowner of class:\fR
nobody.
.PD 0
.TP 20
\fBbaseclasses:\fR
.na
Button
.ad b
.PD 0
.TP 20
\fBsubclasses:\fR
.na
RadioButton, ToggleButton
.ad b
.PD 0
.TP 20
\fBflags:\fR
ButtonFlags

.SH INSTANCE VARIABLES
.TP
.BR highlight " (protected Bitmap *)"
This bitmap is intended to be drawn as selection feedback but is actually not used.

.TP
.BR off " (protected Bitmap *)"
This bitmap is drawn when the state of the button is off. It must not be \fBNULL\fP.

.TP
.BR on " (protected Bitmap *)"
This bitmap is drawn when the state of the button is on. It must not be \fBNULL\fP.

.TP
.BR state " (protected bool)"
the current state of the button. It is accessible through the \fImethod GetValue\fP and the \fImethod SetState\fP.


.SH INSTANCE METHOD LIST

.PD 0
.TP 20
client interface
GetValue
.br
OnOffItem
.br
SetState

.PD 0
.TP 20
implementation
Base
.br
DoOnItem
.br
Draw
.br
GetMinSize
.br
PrintOn
.br
ReadFrom
.br
SendDown

.SH CATEGORIES

.na
Simple Dialog Items
.ad b

.SH FILES
.PD 0
.TP 20
declaration:
\fBButtons.h

.SH HISTORY
joe@csesbg.at	Fri Sep 06 12:10 1991 MET DST
.br
