.po -3
.nh
.TH "Panner" n "automatically Fri Mar 15 14:12:40 1991" "ET++ version v2.2" "ET++ class description"
.SH NAME
Panner \- controls scrolling of a Clipper
.SH DESCRIPTION
The \fBPanner\fP is similar to a scrollbar. However, the \fBPanner\fP allows to scroll the \fBView\fP inside a \fBClipper\fP in any direction and as well gives an overview of the \fBView\fP's size in relation to the \fBClipper\fP's size. Because a \fBPanner\fP is usually rather small, the whole \fBView\fP can be scrolled with little mouse movements.
.br
Example:
.na
.nf

Window *MyDocument::DoMakeWindows()
{
    View *view = new MyView(/* ... */);
    Scroller *scroller = new Scroller(view);
    Panner *panner = new Panner(scroller-\>GetClipper(), Point(40));

    return new Window(this, Point(400), eWinDefault,
                   new Expander(cIdNone, eVert, gPoint4,
                           scroller,
                           panner,
                           NULL
                   )
               );
}

.ad b
.fi


.br
classes are never derived from \fBPanner\fP.
.br
class \fBPanner\fP
is sometimes reused directly.
.br
class \fBPanner\fP contains 5 methods.
.PD 0
.TP 20
\fBowner of class:\fR
nobody.
.PD 0
.TP 20
\fBbaseclasses:\fR
.na
Slider
.ad b
.PD 0
.TP 20
\fBflags:\fR
CompositeVObjectFlags

.SH INSTANCE VARIABLES
.TP
.BR cl " (private Clipper *)"
the \fBClipper\fP that is controlled by the \fBPanner\fP. It must not be \fBNULL\fP.


.SH INSTANCE METHOD LIST

.PD 0
.TP 20
client interface
Panner

.PD 0
.TP 20
implementation
Control
.br
DoObserve
.br
GetMinSize
.br
~Panner

.SH CATEGORIES

.na
Simple Dialog Items
.ad b

.SH FILES
.PD 0
.TP 20
declaration:
\fBPanner.h

.SH KNOWN PROBLEMS

The \fBMetaDef\fP and \fBMetaImpl\fP statements are missing.
.SH HISTORY
joe@csesbg.at	Thu Sep 12 11:23 1991 MET DST
.br
.so mann/Panner::Control.n
.so mann/Panner::DoObserve.n
.so mann/Panner::GetMinSize.n
.so mann/Panner::Panner.n
.so mann/Panner::~Panner.n
