.po -3
.nh
.TH "Scroller" n "automatically Fri Mar 15 14:14:57 1991" "ET++ version v2.2" "ET++ class description"
.SH NAME
Scroller.short \- surrounds a Clipper with ScrollBars
.SH DESCRIPTION
A \fBScroller\fP installs a \fBVObject\fP, usually an instance of the \fIclass View\fP, in a \fBClipper\fP and surrounds that \fBClipper\fP with \fBScrollBars\fP. \fBScrollbars\fP can be placed individually at each side of the \fBClipper\fP. Depending on the flag \fBeScrollHideScrolls\fP of the \fIinstvar controls\fP the installed \fBScrollBars\fP are always visible or they are shown only when necessary.
.br
Nothing special has to be done to put a \fBView\fP in a \fBScroller\fP except that the \fBView\fP must correctly set its size with \fBSetExtent\fP otherwise the \fBScroller\fP cannot update the size of the thumbs (the grey area inside a \fBScrollBar\fP, which can be moved with the left mouse button).
.br
\fBScrollers\fP are used, for example, when the initial window layout is created:
.na
.nf

Window *MyDocument::DoMakeWindows()
{
    View *myView = new MyView(/* ... */);
    return new Window(this, Point(400), eWinDefault,
               new Scroller(myView));
}

.ad b
.fi
It is also possible to install a \fBView\fP directly in a \fBClipper\fP or to put it into a \fBSplitter\fP. See \fIclass Clipper\fP and \fIclass Splitter\fP.

.br
classes are never derived from \fBScroller\fP.
.br
class \fBScroller\fP
is often reused directly.
.br
class \fBScroller\fP contains 16 methods.
.PD 0
.TP 20
\fBowner of class:\fR
nobody.
.PD 0
.TP 20
\fBbaseclasses:\fR
.na
CompositeVObject
.ad b
.PD 0
.TP 20
\fBsubclasses:\fR
.na
SplitScroller
.ad b
.PD 0
.TP 20
\fBflags:\fR
CompositeVObjectFlags

.SH INSTANCE VARIABLES
.TP
.BR controls " (protected ScrollDir)"
specifies on which sides to place \fBScrollBars\fP and whether to hide them when they are not necessary. The default is to create one \fBScrollBar\fP at the right side, one at the bottom and to hide them. See also \fIenum ScrollDir\fP and \fIinstvar visibleControls\fP.

.TP
.BR ms " (protected Point)"
the minimum size of the installed \fBClipper\fP

.TP
.BR sb " (protected ScrollBar *[4])"
an array containing the four \fBScrollBars\fP. \fBsb[0]\fP is the vertical \fBScrollBar\fP at the right side, \fBsb[1]\fP is the horizontal \fBScrollBar\fP at the bottom, \fBsb[2]\fP is the vertical \fBScrollBar\fP at the left side and \fBsb[3]\fP is the horizontal \fBScrollBar\fP at the top. Always all four \fBScrollBars\fP are created regardless of the value of the \fIinstvar controls\fP. But only the currently visible \fBScrollBars\fP are opened and drawn.

.TP
.BR vf " (protected Clipper *)"
the installed \fBClipper\fP that shows the \fIinstvar vop\fP

.TP
.BR visibleControls " (protected ScrollDir)"
indicates which of the four \fBScrollBars\fP are currently visible. See also \fIinstvar controls\fP.

.TP
.BR vop " (protected VObject *)"
the shown \fBVObject\fP. It is usually an instance of the \fIclass View\fP.


.SH INSTANCE METHOD LIST

.PD 0
.TP 20
client interface
GetBgInk
.br
GetClipper
.br
Scroller
.br
SetBgInk

.PD 0
.TP 20
implementation
BubbleUpdate
.br
Control
.br
Draw
.br
GetMinSize
.br
Init
.br
NeedControls
.br
Open
.br
PrintOn
.br
ReadFrom
.br
SetExtent
.br
SetOrigin
.br
ViewSizeChanged

.SH CATEGORIES

.na
VObject Composition
.ad b

.SH FILES
.PD 0
.TP 20
declaration:
\fBScroller.h

.SH HISTORY
joe@csesbg.at	Wed Sep 11 12:29 1991 MET DST
.br
