.po -3
.nh
.TH "ShadowItem" n "automatically Thu Mar 21 20:12:02 1991" "ET++ version v2.2" "ET++ class description"
.SH NAME
ShadowItem \- adds a shadow to a VObject
.SH DESCRIPTION
The \fBShadowItem\fP surrounds a \fBVObject\fP with a border line and draws a shadow at the bottom and the right side of that \fBVObject\fP. Both the shadow and the border line width can be set by the client.

.br
classes are never derived from \fBShadowItem\fP.
.br
class \fBShadowItem\fP
is sometimes reused directly.
.br
class \fBShadowItem\fP contains 11 methods.
.PD 0
.TP 20
\fBowner of class:\fR
nobody.
.PD 0
.TP 20
\fBbaseclasses:\fR
.na
CompositeVObject
.ad b
.PD 0
.TP 20
\fBflags:\fR
CompositeVObjectFlags

.SH INSTANCE VARIABLES
.TP
.BR inner " (private VObject *)"
the inner \fBVObject\fP

.TP
.BR lineWidth " (private int)"
the width of the border line. It can be set with the \fImethod SetLineWidth\fP.
.br
.B Known Problems:
The \fImethod DrawInner\fP never sets the port's line width.

.TP
.BR shadowWidth " (private int)"
the width of the shadow. It can be set with the \fImethod SetShadowWidth\fP.


.SH INSTANCE METHOD LIST

.PD 0
.TP 20
client interface
SetLineWidth
.br
SetShadowWidth
.br
ShadowItem

.PD 0
.TP 20
implementation
Base
.br
DrawHighlight
.br
DrawInner
.br
GetMinSize
.br
PrintOn
.br
ReadFrom
.br
SetExtent
.br
SetOrigin

.SH CATEGORIES

.na
VObject Composition
.ad b

.SH FILES
.PD 0
.TP 20
declaration:
\fBShadowItem.h

.SH HISTORY
joe@csesbg.at	Tue Sep 10 15:50 1991 MET DST
.br
.so mann/ShadowItem::Base.n
.so mann/ShadowItem::DrawHighlight.n
.so mann/ShadowItem::DrawInner.n
.so mann/ShadowItem::GetMinSize.n
.so mann/ShadowItem::PrintOn.n
.so mann/ShadowItem::ReadFrom.n
.so mann/ShadowItem::SetExtent.n
.so mann/ShadowItem::SetLineWidth.n
.so mann/ShadowItem::SetOrigin.n
.so mann/ShadowItem::SetShadowWidth.n
.so mann/ShadowItem::ShadowItem.n
