.po -3
.TH "VObject::DoKeyCommand" n "automatically Mon Apr  8 20:17:57 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
VObject::DoKeyCommand \- instance method
.SH TEMPLATE
commandToPerform = Command *
DoKeyCommand(int keyCode, Point locatorPoint, Token inputToken)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
\fBDoKeyCommand\fP is called by the \fImethod DispatchEvents\fP on normal ASCII key events. By default, the event is passed to the next event handler. If there is no next handler \fBgNoChanges\fP is returned.
Method is sometimes overridden.
.SH ARGUMENTS
.TP
\fBint keyCode
.br
contains the code of the pressed key which is a copy of \fBinputToken.Code\fP. Modifier keys (Shift, Ctrl or Meta) pressed together with the key have already been taken into account.
.br
For example, if Shift and 'a' have been pressed then \fBkeyCode\fP contains 'A'. If the Meta key is pressed then the key code is always incremented by 128 which allows to enter non-ASCII characters that are normally not accessible from a keyboard. If Meta and/or Ctrl have been pressed then the original code can be found out with the \fBinputToken\fP and the \fImethod Token::MapToAscii\fP.
.TP
\fBPoint locatorPoint
.br
see \fImethod DispatchEvents\fP
.TP
\fBToken inputToken
.br
see \fImethod DispatchEvents\fP
.SH RETURN ARGUMENT
.TP
\fBCommand * commandToPerform
.br
see \fImethod DispatchEvents\fP
.SH CATEGORIES

.na
event handling, overrider interface
.ad b

.SH FIRST DEFINITION
class VObject
.SH FILES
.PD 0
.TP 20
implementation:
\fBVObject.C

