.po -3
.TH "VObject::DoLeftButtonDownCommand" n "automatically Mon Apr  8 20:17:57 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
VObject::DoLeftButtonDownCommand \- instance method
.SH TEMPLATE
commandToPerform = Command *
DoLeftButtonDownCommand(Point locatorPoint, Token inputToken, int clicks)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
\fBDoLeftButtonDownCommand\fP is called by the \fImethod DispatchEvents\fP on left mouse button events. The flag \fBeFlgButDown\fP of the \fBinputToken.Flags\fP tells whether the left mouse button has just been pressed or released. If the flag is cleared, then the mouse button has been pressed.
.br
By default, the event is passed to the next event handler. If there is no next handler \fBgNoChanges\fP is returned.
.br
If this method is overridden and it returns a command different from \fBgNoChanges\fP then mouse tracking is started with that command before it is actually executed.
Method is often overridden.
.SH ARGUMENTS
.TP
\fBPoint locatorPoint
.br
see \fImethod DispatchEvents\fP
.TP
\fBToken inputToken
.br
see \fImethod DispatchEvents\fP
.TP
\fBint clicks
.br
contains how often the mouse button was clicked in rapid succession. Two clicks are commonly referred to as \fBdouble click\fP and three clicks are called \fBtriple click\fP. In order to recognize a double or triple click the time between two clicks must be less than 0.5 seconds and between the clicks the mouse must not be moved more than 1 pixel horizontally and vertically. These conditions are checked in the \fImethod Token::DoubleClick\fP. The number of clicks are also stored in the \fIvar Clicks\fP.
.SH RETURN ARGUMENT
.TP
\fBCommand * commandToPerform
.br
see \fImethod DispatchEvents\fP
.SH CATEGORIES

.na
event handling, mouse tracking, overrider interface
.ad b

.SH FIRST DEFINITION
class VObject
.SH FILES
.PD 0
.TP 20
implementation:
\fBVObject.C

