.po -3
.TH "VObject::Input" n "automatically Mon Apr  8 20:17:57 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
VObject::Input \- instance method
.SH TEMPLATE
commandToPerform = Command *
Input(Point locatorPoint, Token inputToken, Clipper * focusClipper)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
\fBInput\fP checks whether an event can be consumed at all by \fBthis\fP. If \fBthis\fP VObject contains the \fBlocatorPoint\fP (see \fImethod ContainsPoint\fP) and it is enabled, then the event is passed to the \fImethod DispatchEvents\fP and the command is returned. If \fBthis\fP doesn't contain the \fBlocatorPoint\fP, then \fBNULL\fP is returned.
Method is rarely overridden.
.SH ARGUMENTS
.TP
\fBPoint locatorPoint
.br
see \fImethod DispatchEvents\fP
.TP
\fBToken inputToken
.br
see \fImethod DispatchEvents\fP
.TP
\fBClipper * focusClipper
.br
see \fImethod DispatchEvents\fP
.SH RETURN ARGUMENT
.TP
\fBCommand * commandToPerform
.br
contains a command to be executed by one of the next event handlers. A \fBDocument\fP will usually execute the command (see \fImethod Document::PerformCommand\fP). If the \fBinputToken\fP has not been handled or \fBthis\fP is disabled then \fBgNoChanges\fP is returned. If \fBthis\fP doesn't contain the \fBlocatorPoint\fP at all then \fBNULL\fP is returned.
.SH CATEGORIES

.na
event handling, client interface, overrider interface
.ad b

.SH FIRST DEFINITION
class VObject
.SH FILES
.PD 0
.TP 20
implementation:
\fBVObject.C

.SH KNOWN PROBLEMS

A \fBVObject\fP should not get input events if it is closed (flag \fBeVObjOpen\fP, see \fIenum VObjFlags\fP). But this test is commented out in the code. See \fImethod VObject::Input\fP.
