.po -3
.TH "VObject::InvalidateRect" n "automatically Mon Apr  8 20:17:57 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
VObject::InvalidateRect \- instance method
.SH TEMPLATE
void InvalidateRect(Rectangle invalidRect)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
\fBInvalidateRect\fP invalidates the area of the \fBinvalidRect\fP that overlaps the content rectangle of \fBthis\fP if \fBthis\fP is open. By passing \fBinvalidRect\fP to the container's \fImethod InvalidateViewRect\fP it is ensured that the origin of \fBinvalidRect\fP is transformed into the container's coordinate system.
.br
Unless the \fImethod UpdateEvent\fP is called sometime after this method, the redrawing occurs only after the window containing \fBthis\fP has processed the next event.
.br
\fBInvalidateRect\fP should be called if only a part of the content rectangle of \fBthis\fP should be invalidated. The \fImethod ForceRedraw\fP however invalidates the whole content rectangle.
.br
See also \fItechnote Invalidation and Drawing\fP.
Method is rarely overridden.
.SH ARGUMENTS
.TP
\fBRectangle invalidRect
.br
a rectangle which must be redrawn and therefore invalidated
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
invalidation, client interface
.ad b

.SH FIRST DEFINITION
class VObject
.SH FILES
.PD 0
.TP 20
implementation:
\fBVObject.C

