.po -3
.TH "VObject::TrackInContent" n "automatically Mon Apr  8 20:17:57 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
VObject::TrackInContent \- instance method
.SH TEMPLATE
commandToPerform = Command *
TrackInContent(Point locatorPoint, Token inputToken, Command * tracker)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
The \fImethod DispatchEvents\fP calls \fBTrackInContent\fP for its \fBfocusClipper\fP argument with the \fBtracker\fP command returned by the \fImethod DoLeftButtonDownCommand\fP or the \fImethod DoMiddleButtonDownCommand\fP.
.br
The default implementation just returns the \fBtracker\fP. Only the \fIclass Clipper\fP overrides this method. The \fImethod Clipper::TrackInContent\fP tracks the mouse and calls the tracking methods of the \fBtracker\fP during the different track phases such as mouse button pressed, mouse moved and button released.
Method is rarely overridden.
.SH ARGUMENTS
.TP
\fBPoint locatorPoint
.br
see \fImethod DispatchEvents\fP
.TP
\fBToken inputToken
.br
see \fImethod DispatchEvents\fP
.TP
\fBCommand * tracker
.br
a mouse tracking command which should have its \fBTrack...\fP methods overridden
.SH RETURN ARGUMENT
.TP
\fBCommand * commandToPerform
.br
the final command to perform or \fBgNoChanges\fP. In most of the cases this command is identical to \fBtracker\fP but it need not be. It is possible to perform mouse tracking with one command and during or after tracking replace it with another undoable command.
.SH CATEGORIES

.na
mouse tracking, implementation
.ad b

.SH FIRST DEFINITION
class VObject
.SH FILES
.PD 0
.TP 20
implementation:
\fBVObject.C

