.po -3
.TH "View::CanPaste" n "automatically Mon Apr  8 20:17:22 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
View::CanPaste \- instance method
.SH TEMPLATE
canPasteData = bool
CanPaste(char * type)
.SH SPECIFIERS
public
abstract
virtual
.SH DESCRIPTION
\fBCanPaste\fP must check whether \fBthis\fP can paste data of type \fBtype\fP from the clipboard. This method is called to find out whether to enable or disable the \fBpaste\fP menu item. The default implementation returns \fBFALSE\fP.
.br
\fBCanPaste\fP should be overridden only together with the \fImethod PasteData\fP.
.br
For example, the \fImethod TextView::CanPaste\fP returns \fBTRUE\fP if the \fBtype\fP is either \fBcDocTypeET\fP or \fBcDocTypeAscii\fP.
Method is sometimes overridden.
.SH ARGUMENTS
.TP
\fBchar * type
.br
is the type of the data contained in the clipboard. Common types are \fBcDocTypeET\fP which indicates ET++ Object Input/Output format and \fBcDocTypeAscii\fP for pure ASCII text.
.SH RETURN ARGUMENT
.TP
\fBbool canPasteData
.br
indicates whether \fBthis\fP can paste data of type \fBtype\fP from the clipboard
.SH CATEGORIES

.na
clipboard, overrider interface
.ad b

.SH FIRST DEFINITION
class View
.SH FILES
.PD 0
.TP 20
implementation:
\fBView.C

