.po -3
.TH "View::SelectionToClipboard" n "automatically Mon Apr  8 20:17:22 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
View::SelectionToClipboard \- instance method
.SH TEMPLATE
void SelectionToClipboard(char * requiredType, ostream & outputStream)
.SH SPECIFIERS
public
abstract
virtual
.SH DESCRIPTION
\fBSelectionToClipboard\fP is called when the \fBcut\fP or \fBcopy\fP command is selected from the popup menu. But these menu items are only enabled if the \fImethod HasSelection\fP returns \fBTRUE\fP.
.br
\fBSelectionToClipboard\fP must write the current selection of \fBthis\fP to the \fBoutputStream\fP in the \fBrequiredType\fP. See the \fImethod TextView::SelectionToClipboard\fP for an example.
.br
See also \fImethod PasteData\fP.
Method is sometimes overridden.
.SH ARGUMENTS
.TP
\fBchar * requiredType
.br
The current selection of \fBthis\fP must be written to the \fBoutputStream\fP in this type. Common types are \fBcDocTypeET\fP which indicates ET++ Object Input/Output format and \fBcDocTypeAscii\fP for pure ASCII text.
.br
The \fBrequiredType\fP can also be set by the client. Before \fBSelectionToClipboard\fP is called the \fImethod ClipBoard::SetType\fP must be applied to the \fIvar gClipBoard\fP. See the \fImethod TextView::DoMenuCommand\fP for an example.
.TP
\fBostream & outputStream
.br
is a stream created by the clipboard where to write the current selection of \fBthis\fP
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
clipboard, overrider interface
.ad b

.SH FIRST DEFINITION
class View
.SH FILES
.PD 0
.TP 20
implementation:
\fBView.C

