.po -3
.nh
.TH "Window" n "automatically Thu Mar 21 20:10:03 1991" "ET++ version v2.2" "ET++ class description"
.SH NAME
Window.short \- a window with a title area and a popup menu
.SH DESCRIPTION
The class \fBWindow\fP provides a decorated window. It contains a title area with buttons to close or iconify the window. There is also a popup menu which provides some window management functions.
.br
Windows are created, for example, in the method \fBDoMakeWindows\fP of a document:
.na
.nf

Window *MyDocument::DoMakeWindows()
{
    return new Window(this, Point(400), eWinDefault,
               new Expander(cIdNone, eVert, gPoint2,
                   new Scroller(new TextView(/* ... */)),
                   // other items
                   NULL
               )
           );
}

.ad b
.fi


.br
classes are rarely derived from \fBWindow\fP.
.br
class \fBWindow\fP
is heavily reused directly.
.br
class \fBWindow\fP contains 8 methods.
.PD 0
.TP 20
\fBowner of class:\fR
nobody.
.PD 0
.TP 20
\fBbaseclasses:\fR
.na
BlankWin
.ad b
.PD 0
.TP 20
\fBflags:\fR
WindowFlags

.SH INSTANCE VARIABLES
.TP
.BR menu " (private Menu *)"
This menu is created in the \fImethod GetMenu\fP. Menu commands for window management functions are added and handled by the \fIclass BlankWin\fP.


.SH INSTANCE METHOD LIST

.PD 0
.TP 20
client interface
GetTitle
.br
SetTitle
.br
Window

.PD 0
.TP 20
implementation
Control
.br
DispatchEvents
.br
GetMenu
.br
MakePort
.br
~Window

.SH CATEGORIES

.na
Application Framework
.ad b

.SH FILES
.PD 0
.TP 20
declaration:
\fBWindow.h

.SH KNOWN PROBLEMS

see \fImethod GetTitle\fP
.SH HISTORY
joe@csesbg.at	Wed Sep 11 12:45 1991 MET DST
.br
