.po -3

.TH "enums" n "automatically Mon Apr  8 20:19:25 1991" "ET++ version " "ET++ enumeration description"
.SH ENUMERATION NAME
\fBVObjFlags
.SH DESCRIPTION
\fBVObjFlags\fP is the set of flags of the \fIclass VObject\fP.
This enumeration is a bitset..SH ENUMITEMS
.TP
\fBeVObjEnabled
description
This flag is set by the \fImethod VObject::Enable\fP. If a VObject is disabled, i.e., this flag is not set, it is usually drawn with a shade of grey or with another color and it does not get events.
.TP
\fBeVObjOpen
description
This flag is set by the \fImethod VObject::Open\fP which in turn is called when a \fBVObject\fP is opened or closed. If a \fBVObject\fP is closed, then it will not be drawn and does not get events.
.TP
\fBeVObjHFixed
description
If this flag is set then the VObject is not horizontally expanded if it is installed in an \fBExpander\fP, for example. See \fIclass Expander\fP.
.TP
\fBeVObjVFixed
description
If this flag is set then the VObject is not vertically expanded if it is installed in an \fBExpander\fP, for example. See \fIclass Expander\fP.
.TP
\fBeVObjLayoutCntl
description
If this flag is set then every time the VObject's content rectangle is changed by the \fImethod VObject::SetOrigin\fP or the \fImethod VObject::SetExtent\fP the next handlers and the observers are notified about this. The next handlers get a message via the method \fBControl\fP whereby the \fBvalue\fP argument contains a pointer to the VObject. The observers are notified via the method \fBDoObserve\fP whereby the \fBvalue\fP argument is the address of a \fBPoint\fP which contains the origin, respectively the extent of the VObject. If the origin has changed then the \fBpartCode\fP argument is \fBcPartOriginChanged\fP otherwise it is \fBcPartExtentChanged\fP. See also \fImethod EvtHandler::Control\fP and \fImethod Object::DoObserve\fP.
.br
This flag is used, for example, by the \fIclass VObjectTextView\fP.
.TP
\fBeVObjKbdFocus
description
A \fBVObject\fP sets this flag when it wants to get the keyboard focus. This is used, for example, in the \fIclass VObjectTextView\fP.
.TP
\fBeVObjDefault
description
the default set of flags is \fBeVObjEnabled\fP
.TP
\fBeVObjLast
description
The first flag of subclasses is \fBBIT(eVObjLast+1)\fP.
.SH CATEGORIES

.na
Graphic Foundation
.ad b

.SH FILES
.PD 0
.TP 20
declaration:
\fBVObject.h
.SH HISTORY
joe@csesbg.at	Fri Sep 06 09:56 1991 MET DST
.br
