/***************************************************************************/
/*	    PROGRAMM  ix/Mbox						   */
/*             DATEI  suchen.c						   */
/*        FUNKTIONEN  weiterleiten()					   */
/*             AUTOR  vs (Volker Schuermann/MINIX-Version)		   */
/*  LETZTE AENDERUNG  10.01.1992					   */
/***************************************************************************/

#include <stdio.h>

#include "mbox.h"


/***************************************************************************/
/*      FUNKTION  suchen()						   */
/*  BESCHREIBUNG  Artikel im aktuellen Brett mit GREP nach muster durch-   */
/* 		  suchen und entsprechende Artikel anzeigen.		   */
/*     PARAMETER  muster = Suchbegriff				           */
/*     RUECKGABE  keine                                                    */
/***************************************************************************/

void suchen( muster )
char muster[];
{
  FILE *fp;

  char s[STRING];
  char t[STRING];
  char tmp[STRING];
  char ex[LONGSTRING];

  int fpid;
  int found = 0;
  int ok = 0;
  int i;
  

  if(muster[0] == '\0'){
	ansi( "md" );
	printf("\n\n%s ", SUC01_MSG);
	ansi( "me" );
	strcpy(muster, (char *) getline(60, 1, 32, ""));
	if(muster[0] == '\0'){
		printf(" <- %s\n", SUC02_MSG);
		return;
	}
  }

  i = 0;
  while(muster[i] != '\0'){
	if(muster[i] == '"') muster[i] = ' ';
	i++;
  }

  sprintf(s, " %s \"%s\" %s [%s] ", SUC03_MSG, (char *) stripped(muster), SUC04_MSG, NG);
  headline( s );

  printf("%s .", SUC05_MSG);

  sprintf(tmp, "%s/such.%d", TMP, getpid());

  if(strcomp("PM", BRETT) == 0){
	sprintf(t, "%s/usr/%d", HOME, USER.id);
	chdir( t );
  }
  else{
	chdir( BRETT );
  }

  switch( (fpid = fork()) ){
		case -1 :
				break;
		case  0 :	while(1){
					printf(".");
					sleep(3);
				}	
				break;
  }

  sprintf(s, "%s \"%s\" * > %s 2> %s", GREP, (char *) stripped(muster), tmp, CPRN);
  system( s );

  kill( fpid, 9 );
  wait( fpid );

  printf("%c", CR);


  fp = fopen( tmp, "r" );
  if(fp == 0){
	
  }
  while((fgets(ex, LONGSTRING, fp) != NULL) && (ok == 0)){
	if(atoi(ex) != 0){	
		if(show( (char *) stripped(ex), 9999, USER.more ) == -1) ok++;
		found++;
	}
  }
  fclose(fp);

  chdir( HOME );

  if(found == 0){
	printf("%s \"%s\" %s\n", SUC06_MSG, (char *) stripped(muster), SUC07_MSG);
  }

  unlink( tmp );
}
