.TH NEWMAIL 1L
.SH NAME
newmail \- display numbers of new, unread, and total mail messages
.SH SYNTAX
.B newmail
[ \fB-b -d -i interval -n -s -t -v\fR ] [ \fBmailbox\fR ]

.B killnewmail

.SH DESCRIPTION
The
.I newmail
command displays the number of messages in the given \fBmailbox\fR,
broken down by new messages, unread messages, and total (including
old) messages.
It also returns as a status code the number of new messages in the
mailbox.
If \fBmailbox\fR is not specified, then it checks the user's default
mailbox,
\*(MB.

.I Killnewmail
is a shell script that kills the
.I newmail
daemon (see the -d option).

.I Newmail
accepts the following flags:

.IP \fB\-b\fP 5
Beep if the mailbox contains new messages.

.IP \fB\-d\fP 5
This option starts
.I newmail
as a daemon which checks the mailbox every
.B interval
seconds.
If
.B interval
is not specified, it defaults to 30 seconds.

.IP \fB\-i interval\fP 5
Specifies a time interval for a delay between repeated mailbox
checks.
This puts the program into an endless loop.
If this option is desired, consider also the \fB-d\fR option.

.IP \fB\-n\fP 5
Inhibits an output message if \fBmailbox\fR contains no messages.

.IP \fB\-s\fP 5
Specifies silent mode.
Nothing is displayed, but the return status gives the number of
messages.
Options \fB-s\fR, \fB-t\fR, and \fB-v\fR are mutually exclusive, and
override one another.

.IP \fB\-t\fP 5
Specifies terse mode.
The numbers of messages are displayed in the form "new unread total",
suitable for piping through \fIawk\fR.

.IP \fB\-v\fP 5
Specifies verbose mode.
Displays the numbers of messages in \fBmailbox\fR in the format
"\*(MB: x new, y unread, z total messages".\ 
If x or y is zero, then the corresponding output field will be
omitted.
Default.
.PP

.SH DIAGNOSTICS
A nonnegative return code specifies the number of new messages in
\fBmailbox\fR.
If the \fB-d\fR option is specified, then the pid of the created
daemon is returned.
A return code of -1 indicates an error.

.SH CAVEAT
When in a looping mode (\fB-i\fR or \fB-d\fR), \fInewmail\fR can miss
messages that arrive within \fBinterval\fR seconds of reading one's
mail (and thus clearing the messages' "new" flags).
This is because \fInewmail\fR is interested only in net increases in
the mailbox message count, and it takes that much time before the
count can be assumed to be reset to zero.

.SH AUTHOR
Written by Steve Creps, Indiana University, October 24, 1988, based
on observation of Unix mailbox format.
Not derived from anyone else's code.
Last modified July 19, 1991.
