/*Copyright  (c)   1992  Adam  Stein.   All  Rights Reserved.   

  Permission to use,  copy,  modify  and  distribute  without
  charge this software, documentation, images, etc. is grant-
  ed, provided that this copyright and the author's  name  is  
  retained.   
  
  A fee may be charged for this program ONLY to recover costs   
  for distribution (i.e. media costs).  No profit can be made            
  on this program.   
   
  The author assumes no responsibility for disasters (natural   
  or otherwise) as a consequence of use of this software.      
   
  Adam Stein (stein.wbst129@xerox.com)         
*/ 

#include <stdio.h>
#include "persim.h"
#include "date.h"

char *program;
double *input,*output,*desired,**weights,ranges[1][2];
NODE_ATTR *node_attr;
STATE state;

/*This program simulates a single layer perceptron.

  Inputs:  argc      - number of command line arguments
	   argv      - command line arguments
  Outputs: 0 (no error status)
  Locals:  none
  Globals: desired   - array of desired output values
	   input     - array of input values
	   node_attr - node attributes (function, threshold)
	   output    - array of output values
	   program   - name of currently executing program
	   ranges    - max and min values (only for step function right now)
	   state     - system variables
	   weights   - perceptron weights
	   NULL	     - 0
*/
main(argc,argv)
register int argc;
register char *argv[];
{
	/*Initialize*/
	program = argv[0];

	state.alpha = 0.1;
	state.inodes = UNKNOWN;
	state.onodes = UNKNOWN;
	state.training = 1;

	ranges[0][0] = -1.0;
	ranges[0][1] = 1.0;

	input = output = desired = (double *) NULL;
	weights = (double **) NULL;
	node_attr = (NODE_ATTR *) NULL;

	/*Start up the parser*/
	if(argc > 1) startup(argv[1]);
	else startup(NULL);

	if(input != (double *) NULL) free(input);
	if(output != (double *) NULL) free(output);
	if(desired != (double *) NULL) free(desired);
	if(weights != (double **) NULL) deallocwts();

	exit(0);
}

/*This routine prints out the interactive prompt.

  Inputs:  none
  Outputs: none
  Locals:  none
  Globals: program - name of currently executing program
*/
prompt()
{
	printf("%s> ",program);
}

/*This routine prints the current version of this program.

  Inputs:  none
  Outputs: none
  Locals:  none
  Globals: DATE        - compilation date
	   TIME        - compilation time
	   VERSION_STR - current version and author
*/
void version()
{
	printf("%s  (Last Compiled: %s @ %s)\n",VERSION_STR,DATE,TIME);
}

