.\" nroff -man %s
.\" UUHOST, Copyright 1992,   Jan-Piet Mens [Logix GmbH, Wiesbaden, Germany]
.\" License to freely use and distribute this software is hereby granted 
.\" by the author, subject to the condition that this copyright notice 
.\" remains intact.  The author retains the exclusive right to publish 
.\" derivative works based on this work, including, but not limited
.\" to, revised versions of this work.
.\"
.\" $Log: uuhost.N,v $
.\" Revision 1.2  1992/01/16  09:42:47  jpm
.\" Cleanup
.\"
.\"
.TH UUHOST 1 "" "Logix GmbH" "Local user commands"
.SH NAME
uuhost - lookup UUCP mail and USENET information
.SH SYNOPSIS
.B uuhost
[
.B -l
]
[
.B -r
.I region
]
[ 
.I hostname
]
.br
.B uuhost
.I -index
.br
.B uulookup
[
.B -h
.I hostname
]
[
.B -m
.I machine
]
[
.B -u
.I address
]
[
.B -v
]
.SH DESCRIPTION
.SS UUHOST 
.RS 1i
.B uuhost
looks up information on the named host
.I hostname
in the UUCP map files and presents the information to the user to peruse.
.PP
.IP "\fBuuhost\fR \fIhostname\fR"
shows information about the host 
.I hostname.
.IP "\fBuuhost\fR \fI-l\fR"
displays a list of uucp map regions available on this system.
.IP "\fBuuhost\fR -r \fIregion\fR"
displays all the information for the specified
.I region.
.IP "\fBuuhost -index\fR"
is reserved for the system administrator. This parses the needed information
out of the UUCP map distribution, and creates the necessary database for
.B uuhost.
This operation should be done once a night, after the maps have arrived at
this site.
.B "uuhost -index"
may be called from a crontab entry.
.PP
.SS UULOOKUP
.RS 1i
.B uulookup 
program parses the
.I UUHOSTINDEX
or
.I PATHALIAS
databases depending on the used option.
.IP "\fBuulookup\fR -h \fIhostname\fR"
looks up information for the host
.I hostname
in the 
.I UUHOSTINDEX
database, and presents the found
.I hostname ,
map-file name, and line number in the map to standard output.
.IP "\fBuulookup\fR -m \fImachine\fR"
looks up information for the machine
.I machine
in the 
.I PATHALIAS
database, and presents the shortest path to that host.
.IP "\fBuulookup\fR -u \fIaddress\fR"
Will print a uucp bang address to the specified
.I address,
which may be a bang address as in
.I site!user
or a domain address as in
.I user@site.
An
.I address
like 
.I user%system@site
will be expanded (if possible) into
.I address!to!that!site!user%system.
If only a site is specified,
.I %s
is output instead of the user.
Note that multiple sites are not supported yet.
.PP
.IP "\fBuulookup\fR \fI-v\fR ..."
turns on verbose output.
.SH DIAGNOSTICS
Many, and (hopefully) self-explanatory.
.SH FILES
.IP "\fIUUHOSTINDEX\fR"
This is the main index file for
.B uuhost.
It contains lines of text, with three fields each. The first field is the
name of a host as in
.I logixwi
followed by a tab character. The second field contains the relative pathname
of the map file 
.I u.deu.2
in which this host is described. The file name does not have a 
.I .Z
tacked on to it, even if the maps are in compressed form (this saves 24KB on our file system :-). The third field is the relative line number in the map file
where the description of the host begins. The 
.B uuhost
index file must be sorted alphabetically. It is parsed by the
.B uulookup
program with option
.I -h
.br
On this system, the 
.I UUHOSTINDEX
file is called "\fI__UUHOSTINDEX__\fR".
.IP "\fIPATHALIAS\fR"
This is the 
.I PATHALIAS 
file as it is used by 
.I smail
or
.I sendmail.
It is parsed by the 
.B uulookup
program with options
.I -m
and 
.I -u
.br
On this system, the
.I PATHALIAS
file is located at "\fI__PATHALIAS__\fR".
.IP "\fIMAPSDIR/u.*\fR"

This directory (\fI__MAPSDIR__\fR on this system) contains the maps. Either compressed (filenames ending in .Z) 
or uncompressed.
.SH NOTES
.B uulookup
is located in the directory
.B __LOOKUPBINDIR__.
.br
.B uulookup
only recognizes one-hop addresses, in other words, 
.I site1!site2!user
is not recognized.
.sp
For
.I uulookup
and
.I uuhost
to work correctly, the
.I PATHALIAS
database and the 
.I UUHOSTINDEX
database must be sorted with
.I sort -u -f
\.
.SH CREDITS
Written by Jan-Piet Mens <jpm@Logix.DE>, based on an idea by 
John Quarterman <jsq@sally.utexas.edu>
.SH SEE ALSO
grep(1), sendmail(1), pathalias(1)
