.po -3
.TH "Collection::Detect" n "automatically Fri Mar  1 10:57:30 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Collection::Detect \- instance method
.SH TEMPLATE
detectedObject = ObjPtr
Detect(BoolFun checkingFunction, void * functionArgument)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
Detect returns an element of the receiver for which checkingFunction
evaluates to TRUE. If there is none such element, 0 is returned.
.br
The argument functionArgument is passed to checkingFunction on every invocation.
It describes the context of evaluation.
.br
The receiver must not be modified in checkingFunction.
.br
For SeqCollections, the returned element is the one with the least index.
.br
See also \fImethod Select\fP.
Method is rarely overridden.
.SH ARGUMENTS
.TP
\fBBoolFun checkingFunction
.br
The arguments are: 
\fB(ObjPtr theReceiver, ObjPtr anElement, void *functionArgument)\fP.
.TP
\fBvoid * functionArgument
.br
Effective type and semantics depend on checkingFunction.
.SH RETURN ARGUMENT
.TP
\fBObjPtr detectedObject
.SH CATEGORIES

.na
enumeration, client interface
.ad b

.SH FIRST DEFINITION
class Collection
.SH FILES
.PD 0
.TP 20
implementation:
\fBCollection.C

.SH KNOWN PROBLEMS

The current implementation allows limited modifications of the receiver
due to the use of an iterator. Exploiting this fact results in a
implementation dependency.
